#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# === RBT::Actions::MetaActions
#
# This file allows the user to batch-compile software, that is, compile
# all entries (in the primary Array) 1:1.
#
# Note that this file will pull in the file rbt/actions/actions.rb.
# =========================================================================== #
# require 'rbt/actions/meta_actions/batch_compile.rb'
# RBT::Actions::MetaActions.batch_compile(ARGV)
# =========================================================================== #
module RBT

module Actions

module MetaActions # === RBT::Actions::MetaActions

  require 'rbt/actions/actions.rb'

  # ========================================================================= #
  # === RBT::Actions::MetaActions.batch_compile
  # ========================================================================= #
  def self.batch_compile(i = ARGV)
    RBT.action(:ChainCompile, i)
  end

end; end; end

if __FILE__ == $PROGRAM_NAME
  RBT::Actions::MetaActions.batch_compile(ARGV)
end # batch_compile ruby php python