#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'rbt/linux/linux_from_scratch/lfs/reset.rb'
# =========================================================================== #
module RBT

module Linux

class LFS < Base # === RBT::LFS

  # ========================================================================= #
  # === reset
  # ========================================================================= #
  def reset
    super()
    infer_the_namespace
    # ======================================================================= #
    # === @sources_dir
    # ======================================================================= #
    @sources_dir = source_directory?
    # ======================================================================= #
    # === @mounted_sources_directory
    # ======================================================================= #
    @mounted_sources_directory = "#{MOUNT_DIR}sources/"
    # ======================================================================= #
    # === @mounted_temp_directory
    # ======================================================================= #
    @mounted_temp_directory    = MOUNT_DIR+'temp/'
  end

end; end; end