#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'rbt/requires/require_the_cookbook_utility_scripts.rb'
# =========================================================================== #
module RBT

  require 'rbt/project/project.rb'

  # ========================================================================= #
  # === RBT.require_the_cookbook_utility_scripts
  # ========================================================================= #
  def self.require_the_cookbook_utility_scripts
    Dir["#{RBT.base_directory?}cookbooks/*.rb"].uniq.each {|file|
      require "rbt/cookbooks/#{File.basename(file)}"
    }
  end

  require_the_cookbook_utility_scripts # Load these .rb files at once.

end