#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'rbt/requires/require_the_classes_for_individual_programs.rb'
# =========================================================================== #
module RBT

  require 'rbt/project/project.rb'

  # ========================================================================= #
  # === RBT.require_the_classes_for_individual_programs
  # ========================================================================= #
  def self.require_the_classes_for_individual_programs
    Dir[
      "#{RBT.project_base_directory?}misc/classes_for_individual_programs/*.rb"
    ].uniq.each {|file|
      require "rbt/misc/classes_for_individual_programs/#{File.basename(file)}"
    }
  end

end