#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'rbt/requires/require_the_generate_files_classes.rb'
# =========================================================================== #
module RBT

  require 'rbt/project/project.rb'

  # ========================================================================= #
  # === RBT.require_the_generate_files_classes
  # ========================================================================= #
  def self.require_the_generate_files_classes
    Dir["#{RBT.base_directory?}/generate_files/*.rb"].uniq.each {|file|
      require "rbt/generate_files/#{File.basename(file)}"
    }
  end

  require_the_generate_files_classes # Load these files at once.

end