#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'rbt/requires/require_the_registered_components.rb'
# =========================================================================== #
module RBT

  require 'rbt/project/project.rb'

  # ========================================================================= #
  # === RBT.require_the_registered_components
  #
  # This method will require all .rb files under the rbt/registered/
  # directory.
  # ========================================================================= #
  def self.require_the_registered_components
    Dir["#{RBT.base_directory?}registered/*.rb"].each {|file|
      require "rbt/registered/#{File.basename(file)}"
    }
  end

end